<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Tests\TestCase;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhu;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaHodnotenia;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\ZoznamPoctuKontrolPodlaDruhu;

/**
 * Class ZoznamPoctuKontrolPodlaDruhuTest
 *
 * @package Seka\Portal\Modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects
 */
class ZoznamPoctuKontrolPodlaDruhuTest extends TestCase
{
    /**
     *
     */
    public function testInstance()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaDruhu();

        self::assertInstanceOf(ZoznamPoctuKontrolPodlaDruhu::class, $zoznam);
    }

    /**
     *
     */
    public function testAddInstanciaInejTriedy()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaDruhu();

        self::expectException(InvalidArgumentException::class);

        $zoznam->add(new PocetKontrolPodlaHodnotenia(
            HodnotenieEmisnejKontrolyEnum::SPOSOBILE(),
            11
        ));
    }

    /**
     *
     */
    public function testAddRovnakyDruhKontroly()
    {
        $zoznam = new ZoznamPoctuKontrolPodlaDruhu();

        for ($a = 0; $a < 3; ++$a) {
            $pocetKontrolPodlaDruhu = new PocetKontrolPodlaDruhu(
                DruhEmisnejKontrolyEnum::PRAVIDELNA(),
                33
            );

            $zoznam->add($pocetKontrolPodlaDruhu);
        }

        self::assertCount(1, $zoznam);

        for ($a = 0; $a < 3; ++$a) {
            $pocetKontrolPodlaDruhu = new PocetKontrolPodlaDruhu(
                DruhEmisnejKontrolyEnum::OPAKOVANA_PRAVIDELNA(),
                3
            );

            $zoznam->add($pocetKontrolPodlaDruhu);
        }

        self::assertCount(2, $zoznam);
    }
}
